using System;
using System.Collections.Generic;
//using System.ComponentModel;
//using System.Data;
//using System.Text;
using System.Windows.Forms;
using System.Linq;
using System.Data.Linq;

using System.Xml;
using System.Xml.Linq;

using SqlProc;

namespace MyMoney
{
	public partial class FormMain : Form
	{
		Money _db;
		IQueryable<Normal> _normal;

		string _cnnString;
		string _ado_cnnString;
		public FormMain()
		{
			InitializeComponent();
			_cnnString = Environment.CurrentDirectory + "\\MyMoney.sdf";
			_ado_cnnString = "Provider=Microsoft.SQLSERVER.CE.OLEDB.3.5;Data Source=" + _cnnString + ";";
			_db = new Money(_cnnString);
		}

		private void FormMain_Load(object sender, EventArgs e)
		{
			CreateQueryMenu();
			CreateConvertMenu();
			radioButton_Outgo.Checked = true;
			monthCalendar_Date.Tag = monthCalendar_Date.SelectionStart;
		}
		private void radioButton_Outgo_CheckedChanged(object sender, EventArgs e)
		{
			_normal = from d in _db.NormalIO where radioButton_Income.Checked == d.IsIncome select d;
			RefreshAll();
		}
		private void monthCalendar_Date_DateChanged(object sender, DateRangeEventArgs e)
		{
			//ʹûκ룬monthCalendarÿӻᷢϢҪ˵ûõϢ
			if ((DateTime)monthCalendar_Date.Tag != monthCalendar_Date.SelectionStart)
			{
				monthCalendar_Date.Tag = monthCalendar_Date.SelectionStart;
				RefreshGrid();
			}
		}
		private void RefreshAll()
		{
			comboBox_Category.Text = null;
			comboBox_Category.DataSource = _normal.Select(d => d.Category).Distinct().OrderByDescending(d => (from dd in _normal where dd.Category == d select dd.AppendedTime).Max());
			comboBox_Place.Text = null;
			comboBox_Place.DataSource = _normal.Select(d => d.Place).Distinct().OrderByDescending(d => (from dd in _normal where dd.Place == d select dd.AppendedTime).Max());
			comboBox_Person.Text = null;
			comboBox_Person.DataSource = _normal.Select(d => d.Person).Distinct().OrderByDescending(d => (from dd in _normal where dd.Person == d select dd.AppendedTime).Max());
			comboBox_PriceUnit.Text = null;
			comboBox_PriceUnit.DataSource = _normal.Select(d => d.PriceUnit).Distinct().OrderByDescending(d => (from dd in _normal where dd.PriceUnit == d select dd.AppendedTime).Max());
			comboBox_QuantityUnit.Text = null;
			comboBox_QuantityUnit.DataSource = _normal.Select(d => d.QuantityUnit).Distinct().OrderByDescending(d => (from dd in _normal where dd.QuantityUnit == d select dd.AppendedTime).Max());

			monthCalendar_Date.BoldedDates = (from d in _normal select d.Date).Distinct().ToArray();
			RefreshGrid();
		}
		private void RefreshGrid()
		{
			DateTime t = monthCalendar_Date.SelectionStart;
			dataGridView_Day.DataSource = from d in _normal
										  where d.Date == t
										  orderby d.AppendedTime descending
										  select new
										  {
											  d.Category,
											  d.Class,
											  d.Item,
											  Price = d.Price.ToString() + " " + d.PriceUnit + "/" + d.QuantityUnit,
											  Quantity = d.Quantity.ToString() + " " + d.QuantityUnit,
											  Amount = d.Amount.ToString() + " " + d.PriceUnit,
											  d.Place,
											  d.Person,
											  d.Note,
											  d.AppendedTime
										  };
			textBox_TotalAmount.Text = (from d in _normal where d.Date == t select d.Amount).Sum().ToString(); //Sum()ҪAmount"decimal?"
			textBox_TotalRows.Text = dataGridView_Day.RowCount.ToString();
			calInput_Price.Text = null;
			calInput_Quantity.Text = "1";
			calInput_Amount.Text = null;
			textBox_Note.Text = null;
		}

		#region comboBox manipulation
		//bool cb_lock = false;
		private void comboBox_Category_TextChanged(object sender, EventArgs e)
		{
			//if (cb_lock) return;
			comboBox_Class.Text = null;
			comboBox_Class.DataSource = (from d in _normal where d.Category == comboBox_Category.Text select d.Class).Distinct().OrderByDescending(d => (from dd in _normal where dd.Class == d && dd.Category == comboBox_Category.Text select dd.AppendedTime).Max());
		}
		private void comboBox_Class_TextChanged(object sender, EventArgs e)
		{
			//if (cb_lock) return;
			//if (button_Modify.Enabled) return;
			//cb_lock = true;
			comboBox_Item.Text = null;
			comboBox_Item.DataSource = (from d in _normal where d.Category == comboBox_Category.Text && d.Class == comboBox_Class.Text select d.Item).Distinct().OrderByDescending(d => (from dd in _normal where dd.Item == d && dd.Class == comboBox_Class.Text && dd.Category == comboBox_Category.Text select dd.AppendedTime).Max());
			//cb_lock = false;
		}
		private void comboBox_Item_TextChanged(object sender, EventArgs e)
		{
			//if (cb_lock) return;
			//var t = from d in _normal where d.Item == comboBox_Item.Text select new { d.Class, d.Category };
			//if (t != null && (t.Any(d => d.Class != comboBox_Class.Text) || t.Any(d => d.Category != comboBox_Category.Text)))
			//{
			//    cb_lock = true;
			//    comboBox_Class.Text = t.First().Class;
			//    comboBox_Category.Text = t.First().Category;
			//    cb_lock = false;
			//}
		}
		#endregion

		#region dataGridView manipulation
		int curRowIndex = -1;
		bool cellClicked = false;
		private void dataGridView_Day_CellMouseDown(object sender, DataGridViewCellMouseEventArgs e)
		{
			if (curRowIndex != e.RowIndex)
			{
				curRowIndex = e.RowIndex;
				cellClicked = true;
			}
			else
			{
				curRowIndex = -1;
				dataGridView_Day.ClearSelection();
			}
		}
		private void dataGridView_Day_SelectionChanged(object sender, EventArgs e)
		{
			if (cellClicked && curRowIndex >= 0 && curRowIndex < dataGridView_Day.Rows.Count)
			{
				comboBox_Category.SelectedItem = dataGridView_Day["Category", curRowIndex].Value;
				comboBox_Class.SelectedItem = dataGridView_Day["Class", curRowIndex].Value;
				comboBox_Item.SelectedItem = dataGridView_Day["Item", curRowIndex].Value;
				calInput_Price.Text = dataGridView_Day["Price", curRowIndex].Value.ToString().Split()[0];
				comboBox_PriceUnit.SelectedItem = dataGridView_Day["Amount", curRowIndex].Value.ToString().Split()[1];
				calInput_Quantity.Text = dataGridView_Day["Quantity", curRowIndex].Value.ToString().Split()[0];
				comboBox_QuantityUnit.SelectedItem = dataGridView_Day["Quantity", curRowIndex].Value.ToString().Split()[1];
				calInput_Amount.Text = dataGridView_Day["Amount", curRowIndex].Value.ToString().Split()[0];
				comboBox_Place.SelectedItem = dataGridView_Day["Place", curRowIndex].Value;
				comboBox_Person.SelectedItem = dataGridView_Day["Person", curRowIndex].Value;
				textBox_Note.Text = (string)dataGridView_Day["Note", curRowIndex].Value;
				button_Delete.Enabled = true;
				button_Modify.Enabled = true;
			}
			else
			{
				dataGridView_Day.ClearSelection();
				dataGridView_Day.CurrentCell = null;
				button_Delete.Enabled = false;
				button_Modify.Enabled = false;
			}
			cellClicked = false;
		}
		#endregion

		#region calInput manipulation
		object[] cal_last = new object[2];
		bool cal_lock = false;
		private void calInput_ValueChanged(object sender, EventArgs e)
		{
			if (cal_lock) return;
			cal_lock = true;
			if (sender != cal_last[0])
			{
				cal_last[1] = cal_last[0];
				cal_last[0] = sender;
			}

			if (!cal_last.Contains(calInput_Amount))
			{
				calInput_Amount.Text = (calInput_Price.Value * calInput_Quantity.Value).ToString();
			}
			else if (!cal_last.Contains(calInput_Price))
			{
				if (calInput_Quantity.Value == 0)
				{
					if (sender == calInput_Amount)
					{
						calInput_Quantity.Text = "1";
					}
					calInput_Price.Text = calInput_Amount.Value.ToString();
				}
				else
				{
					calInput_Price.Text = (calInput_Amount.Value / calInput_Quantity.Value).ToString();
				}
			}
			else
			{
				if (calInput_Price.Value == 0)
				{
					if (sender == calInput_Amount)
					{
						calInput_Price.Text = calInput_Amount.Value.ToString();
						cal_last[1] = calInput_Quantity;
					}
					calInput_Quantity.Text = "1";
				}
				else
				{
					calInput_Quantity.Text = (calInput_Amount.Value / calInput_Price.Value).ToString();
				}
			}
			cal_lock = false;

		}
		#endregion

		private void button_Append_Click(object sender, EventArgs e)
		{
			if (calInput_Amount.Value == 0) return;
			Normal t = new Normal
			{
				AppendedTime = DateTime.Now,
				Date = monthCalendar_Date.SelectionStart,
				Category = comboBox_Category.Text.Trim(),
				Class = comboBox_Class.Text.Trim(),
				Item = comboBox_Item.Text.Trim(),
				Price = calInput_Price.Value == 0 ? calInput_Amount.Value / calInput_Quantity.Value : calInput_Price.Value,
				PriceUnit = comboBox_PriceUnit.Text.Trim(),
				Quantity = calInput_Quantity.Value == 0 ? calInput_Amount.Value / calInput_Price.Value : calInput_Quantity.Value,
				QuantityUnit = comboBox_QuantityUnit.Text.Trim(),
				Amount = calInput_Amount.Value,
				IsIncome = radioButton_Income.Checked,
				Place = comboBox_Place.Text.Trim(),
				Person = comboBox_Person.Text.Trim(),
				Note = textBox_Note.Text.Trim()
			};
			_db.NormalIO.InsertOnSubmit(t);
			_db.SubmitChanges();
			RefreshAll();
		}
		private void button_Delete_Click(object sender, EventArgs e)
		{
			DateTime t = (DateTime)dataGridView_Day[9, curRowIndex].Value;
			_db.NormalIO.DeleteOnSubmit((_normal.Where(d => d.AppendedTime == t)).First());
			_db.SubmitChanges();
			RefreshAll();
		}
		private void button_Modify_Click(object sender, EventArgs e)
		{
			if (calInput_Amount.Value == 0) return;
			DateTime t = (DateTime)dataGridView_Day["AppendedTime", curRowIndex].Value;
			var m = (_normal.Where(d => d.AppendedTime == t)).First();
			m.Category = comboBox_Category.Text.Trim();
			m.Class = comboBox_Class.Text.Trim();
			m.Item = comboBox_Item.Text.Trim();
			m.Price = calInput_Price.Value;
			m.Quantity = calInput_Quantity.Value;
			m.Amount = calInput_Amount.Value;
			m.PriceUnit = comboBox_PriceUnit.Text.Trim();
			m.Place = comboBox_Place.Text.Trim();
			m.QuantityUnit = comboBox_QuantityUnit.Text.Trim();
			m.Person = comboBox_Person.Text.Trim();
			m.Note = textBox_Note.Text.Trim();
			_db.SubmitChanges();
			RefreshAll();
		}

		private void fileToolStripMenuItem_Exit_Click(object sender, EventArgs e)
		{
			this.Close();
		}

		private void fileToolStripMenuItem_Import_Click(object sender, EventArgs e)
		{
			OpenFileDialog ofd = new OpenFileDialog();
			ofd.Filter = "SQL Server Compact Databases (*.sdf)|*.sdf|All Files (*.*)|*.*";
			if (ofd.ShowDialog() == DialogResult.OK)
			{
				if (MessageBox.Show("Are you sure you want to merge " + ofd.FileName + " into the database?", "Confirm Merge", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
				{
					Money m = new Money(ofd.FileName);
					_db.NormalIO.InsertAllOnSubmit(m.NormalIO);
					_db.SubmitChanges();
					RefreshAll();
					MessageBox.Show("Success!");
				}
			}
		}

		private void fileToolStripMenuItem_Import_Old_Click(object sender, EventArgs e)
		{
			OpenFileDialog ofd = new OpenFileDialog();
			ofd.Filter = "Access Databases (*.mdb)|*.mdb|All Files (*.*)|*.*";
			if (ofd.ShowDialog() == DialogResult.OK)
			{
				if (MessageBox.Show("Are you sure you want to merge " + ofd.FileName + " into the database?", "Confirm Merge", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
				{
					string cnn = "Provider=Microsoft.Jet.Oledb.4.0;Data Source=" + ofd.FileName + ";";
					var data = SqlTool.ReaderQuery("select * from NormalOutgo", cnn);
					while (data.Read())
					{
						Normal t = new Normal
						{
							AppendedTime = (DateTime)data["AppendedTime"],
							Date = (DateTime)data["Date"],
							Category = (string)data["Category"],
							Class = "",
							Item = (string)data["Item"],
							Price = (decimal)data["Amount"],
							PriceUnit = "",
							Quantity = 1,
							QuantityUnit = "",
							Amount = (decimal)data["Amount"],
							IsIncome = false,
							Place = "",
							Person = (string)data["Person"],
							Note = (string)data["Note"]
						};
						_db.NormalIO.InsertOnSubmit(t);
					}
					data = SqlTool.ReaderQuery("select * from NormalIncome", cnn);
					while (data.Read())
					{
						Normal t = new Normal
						{
							AppendedTime = (DateTime)data["AppendedTime"],
							Date = (DateTime)data["Date"],
							Category = (string)data["Category"],
							Class = "",
							Item = (string)data["Item"],
							Price = (decimal)data["Amount"],
							PriceUnit = "",
							Quantity = 1,
							QuantityUnit = "",
							Amount = (decimal)data["Amount"],
							IsIncome = true,
							Place = "",
							Person = (string)data["Person"],
							Note = (string)data["Note"]
						};
						_db.NormalIO.InsertOnSubmit(t);
					}
					_db.SubmitChanges();
					RefreshAll();
					MessageBox.Show("Success!");
				}
			}
		}

		void CreateQueryMenu(ToolStripMenuItem menu, XElement xe)
		{
			foreach (var q in xe.Elements())
			{
				if (q.Name == "Query")
				{
					string name = q.Attribute("name").Value;
					string sql = q.Value.Replace("\n", " ").Trim();
					var menuitem = new ToolStripMenuItem(name);
					menuitem.Click += (sender, e) => SqlForm.ShowQueryResult(sql, _ado_cnnString);
					menu.DropDownItems.Add(menuitem);
				}
				else if (q.Name == "Separator")
				{
					queryToolStripMenuItem.DropDownItems.Add(new ToolStripSeparator());
				}
				else if (q.Name == "Queries")
				{
					string name = q.Attribute("name").Value;
					ToolStripMenuItem t = new ToolStripMenuItem(name);
					queryToolStripMenuItem.DropDownItems.Add(t);
					CreateQueryMenu(t, q);
				}
			}
		}
		void CreateQueryMenu()
		{
			string queryfile = Environment.CurrentDirectory + "\\query.xml";
			if (System.IO.File.Exists(queryfile))
			{
				SqlForm.DefaultRect.Size = new System.Drawing.Size(680, 480);
				CreateQueryMenu(queryToolStripMenuItem, XElement.Load(queryfile));
			}
		}

		//void CreateConvertMenu(ToolStripMenuItem menu, XElement xe)
		//{
		//    foreach (var q in xe.Elements())
		//    {
		//        if (q.Name == "Convertion")
		//        {
		//            string name1 = q.Attribute("name1").Value;
		//            string name2 = q.Attribute("name2").Value;
		//            decimal ratio = decimal.Parse(q.Attribute("ratio").Value);
		//            int i = int.Parse(q.Attribute("status").Value);
		//            var menuitem = new ToolStripMenuItem(name1 + "<->" + name2);
		//            menuitem.CheckState = (CheckState)i;
		//            menuitem.Click += (sender, e) =>
		//                {
		//                };
		//            menu.DropDownItems.Add(menuitem);
		//        }
		//        else if (q.Name == "Separator")
		//        {
		//            queryToolStripMenuItem.DropDownItems.Add(new ToolStripSeparator());
		//        }
		//        else if (q.Name == "Convertions")
		//        {
		//            string name = q.Attribute("name").Value;
		//            ToolStripMenuItem t = new ToolStripMenuItem(name);
		//            convertToolStripMenuItem.DropDownItems.Add(t);
		//            CreateConvertMenu(t, q);
		//        }
		//    }
		//}

		//void CreateConvertMenu()
		//{
		//    string queryfile = Environment.CurrentDirectory + "\\convert.xml";
		//    if (System.IO.File.Exists(queryfile))
		//    {
		//        XElement xe = XElement.Load(queryfile);
		//        foreach (var q in xe.Elements())
		//        {
		//            string name = q.Name.ToString();
		//            ToolStripMenuItem t = new ToolStripMenuItem(name);
		//            convertToolStripMenuItem.DropDownItems.Add(t);
		//            foreach (var qq in q.Elements())
		//            {
		//                name = qq.Name.ToString();
		//                var menuitem = new ToolStripMenuItem(name);
		//                decimal ratio = decimal.Parse(qq.Attribute("ratio").Value);
		//                bool selected = false;
		//                if (qq.Attribute("selected") != null) selected = bool.Parse(qq.Attribute("selected").Value);
		//                menuitem.Checked = selected;
		//                t.DropDownItems.Add(menuitem);
		//            }
		//        }
		//    }
		//}
		void CreateConvertMenu()
		{
			foreach (string uc in _db.Convert.Select(d => d.UnitCategory).Distinct())
			{
				ToolStripMenuItem t = new ToolStripMenuItem(uc);
				convertToolStripMenuItem.DropDownItems.Add(t);
				foreach (var u in _db.Convert.Where(d => d.UnitCategory == uc))
				{
					var menuitem = new ToolStripMenuItem(u.UnitName);
					menuitem.Checked = u.Selected;
					Convertion uu = u; //һ䣬ֱʹuĻհȷ׽uֵʱбհֻʹuһֵuѭйء
					menuitem.Click += (sender, e) =>
						{
							//if (menuitem.Checked)
							//{
							//    u.Selected = false;
							//    _db.SubmitChanges();
							//    menuitem.Checked = false;
							//}
							//else
							//{
							//    var x = _db.Convert.Where(d => d.UnitCategory == uc && d.Selected).FirstOrDefault();
							//    if (x != null)
							//    {
							//        x.Selected = false;

							//    }
							//    u.Selected = true;
							//    _db.SubmitChanges();
							//    foreach (ToolStripMenuItem m in t.DropDownItems)
							//    {
							//        m.Checked = false;
							//    }
							//    menuitem.Checked = true;
							//}
							dataGridView_Day.DataSource = from d in _normal
														  join dd in _db.Convert on d.QuantityUnit equals dd.UnitName into gj
														  from g in gj.DefaultIfEmpty() //Perform a Left Outer Join
														  where d.Date == monthCalendar_Date.SelectionStart
														  orderby d.AppendedTime descending
														  select new
														  {
															  d.Category,
															  d.Class,
															  d.Item,
															  Price = g.UnitCategory == uu.UnitCategory ? ((decimal)((double)d.Price * g.Ratio /(double)uu.Ratio )).ToString() + " " + d.PriceUnit + "/" + uu.UnitName : d.Price.ToString() + " " + d.PriceUnit + "/" + d.QuantityUnit,
															  Quantity = g.UnitCategory == uu.UnitCategory ? ((decimal)((double)d.Quantity * uu.Ratio / (double)g.Ratio)).ToString() + " " + uu.UnitName : d.Quantity.ToString() + " " + d.QuantityUnit,
															  Amount = d.Amount.ToString() + " " + d.PriceUnit,
															  d.Place,
															  d.Person,
															  d.Note,
															  d.AppendedTime
														  };
						};
					t.DropDownItems.Add(menuitem);
				}
			}
		}

		private void advanceToolStripMenuItem_SQL_Click(object sender, EventArgs e)
		{
			SqlForm.DefaultRect.Size = new System.Drawing.Size(680, 480);
			SqlForm.ShowQueryForm(_ado_cnnString, Properties.Settings.Default);
		}

		private void advanceToolStripMenuItem_RunScript_Click(object sender, EventArgs e)
		{
			SqlForm.RunScript(_ado_cnnString);
		}

		private void helpToolStripMenuItem_About_Click(object sender, EventArgs e)
		{
			MessageBox.Show(string.Format("MyMoney v{0}\r\nCopyright(C) Long, Qian\r\nlongqian9509@gmail.com", System.Reflection.Assembly.GetExecutingAssembly().GetName().Version), "About MyMoney", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

	}
}