using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Windows.Forms;
using System.ComponentModel;
using System.Linq;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using SqlProc;

namespace MyMoney
{
	[Table]
	public class Normal
	{
		[Column]
		public DateTime Date;
		[Column]
		public string Category;
		[Column]
		public string Class;
		[Column]
		public string Item;
		[Column]
		public decimal Price;
		[Column]
		public string PriceUnit;
		[Column]
		public decimal Quantity;
		[Column]
		public string QuantityUnit;
		[Column]
		public decimal? Amount;
		[Column]
		public bool IsIncome;
		[Column]
		public string Place;
		[Column]
		public string Person;
		[Column]
		public string Note;
		[Column(IsPrimaryKey = true)]
		public DateTime AppendedTime;
	}
	[Table]
	public class Convertion
	{
		[Column(IsPrimaryKey = true)]
		public string UnitName;
		[Column]
		public string UnitCategory;
		[Column]
		public double Ratio;
		[Column]
		public bool Selected;
	}
	public class Money : DataContext
	{
		public Table<Normal> NormalIO;
		public Table<Convertion> Convert;
		public Money(string connection)
			: base(connection)
		{
			if (!this.DatabaseExists())
			{
				this.CreateDatabase();
			}
			if (this.ExecuteQuery<string>("select TABLE_NAME from INFORMATION_SCHEMA.TABLES where TABLE_NAME='Normal'").Count() == 0)
			{
			}
			if (this.ExecuteQuery<string>("select TABLE_NAME from INFORMATION_SCHEMA.TABLES where TABLE_NAME='Convertion'").Count() == 0)
			{
				//this.ExecuteCommand("create table Convertion(UnitName nvarchar(4000) PRIMARY KEY,UnitCategory nvarchar(4000),Ratio numeric(29,4) NOT NULL,Selected bit NOT NULL)");
				this.ExecuteCommand("create table Convertion(UnitName nvarchar(4000) PRIMARY KEY,UnitCategory nvarchar(4000),Ratio float NOT NULL,Selected bit NOT NULL)");
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "", UnitCategory = "Weight", Ratio = 1, Selected = false });
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "", UnitCategory = "Weight", Ratio = 2.2046226, Selected = false });
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "", UnitCategory = "Weight", Ratio = 1000, Selected = false });
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "˾", UnitCategory = "Weight", Ratio = 35.2739619, Selected = false });
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "", UnitCategory = "Volume", Ratio = 1, Selected = false });
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "", UnitCategory = "Volume", Ratio = 1000, Selected = false });
				this.Convert.InsertOnSubmit(new Convertion { UnitName = "", UnitCategory = "Volume", Ratio = 264.1720524, Selected = false });
				this.SubmitChanges();
			}
		}
	}
}
