using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Common;
using System.Windows.Forms;

namespace SqlProc
{
	//Щûʵ֣.net frameworkвûʵSqlCeFactory
	//磺SqlCeConnection֧GetSchema("Tables")
	//public class MySqlCeFactory : DbProviderFactory
	//{
	//    static DbProviderFactory _instance = new MySqlCeFactory();
	//    MySqlCeFactory()
	//    {
	//    }
	//    public static DbProviderFactory Instance
	//    {
	//        get
	//        {
	//            return _instance;
	//        }
	//    }
	//    public override DbCommand CreateCommand()
	//    {
	//        return new System.Data.SqlServerCe.SqlCeCommand();
	//    }
	//    public override DbConnection CreateConnection()
	//    {
	//        return new System.Data.SqlServerCe.SqlCeConnection();
	//    }
	//    public override DbDataAdapter CreateDataAdapter()
	//    {
	//        return new System.Data.SqlServerCe.SqlCeDataAdapter();
	//    }
	//    public override DbCommandBuilder CreateCommandBuilder()
	//    {
	//        return new System.Data.SqlServerCe.SqlCeCommandBuilder();
	//    }
	//    public override DbParameter CreateParameter()
	//    {
	//        return new System.Data.SqlServerCe.SqlCeParameter();
	//    }
	//}

	public static class SqlTool
	{
		public static DbProviderFactory dbFactory = System.Data.OleDb.OleDbFactory.Instance;
		//public static DbProviderFactory dbFactory = System.Data.SqlClient.SqlClientFactory.Instance;
		//public static DbProviderFactory dbFactory = System.Data.Odbc.OdbcFactory.Instance;
		//public static DbProviderFactory dbFactory = MySqlCeFactory.Instance;

		public static void BuildTree(TreeView tv, string cnnString)
		{
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				cnn.ConnectionString = cnnString;
				cnn.Open();
				Dictionary<string, string> tabledict = new Dictionary<string, string>();
				using (DataTable dtable = cnn.GetSchema("Tables"))
				{
					foreach (DataRow row in dtable.Rows)
					{
						tabledict.Add((string)row["TABLE_NAME"], (string)row["TABLE_TYPE"]);
					}
				}
				SortedList<int, string> typedict = new SortedList<int, string>();
				using (DataTable dtype = cnn.GetSchema("DataTypes"))
				{
					foreach (DataRow row in dtype.Rows)
					{
						short d = (short)row["NativeDataType"];
						if (!typedict.ContainsKey(d))
						{
							typedict.Add(d, (string)row["TypeName"]);
						}
					}
				}
				using (DataTable dcolumn = cnn.GetSchema("Columns"))
				{
					tv.BeginUpdate();
					tv.Nodes.Clear();
					foreach (DataRow row in dcolumn.Select(null, "ORDINAL_POSITION ASC"))
					{
						string table_name = (string)row["TABLE_NAME"];
						string table_type = tabledict[table_name];
						if (table_type == "TABLE" || table_type == "VIEW")
						{
							if (!tv.Nodes.ContainsKey(table_name))
							{
								tv.Nodes.Add(table_name, table_name + " : " + table_type);
							}
							tv.Nodes[table_name].Nodes.Add((string)row["COLUMN_NAME"] + " : " + typedict[(int)row["DATA_TYPE"]]);
						}
					}
					tv.EndUpdate();
				}
			}
		}

		public enum QueryType { Schema, Table, SQL };
		public static DataTable ExecuteQuery(string queryString, string cnnString, QueryType qtype, out int rows)
		{
			DataTable dt = null;
			switch (qtype)
			{
				case QueryType.Schema:
					using (DbConnection cnn = dbFactory.CreateConnection())
					{
						cnn.ConnectionString = cnnString;
						cnn.Open();
						dt = queryString == "" ? cnn.GetSchema() : cnn.GetSchema(queryString);
						rows = dt.Rows.Count;
					}
					break;
				case QueryType.Table:
					dt = TableQuery(queryString, cnnString);
					rows = dt.Rows.Count;
					break;
				case QueryType.SQL:
					if (queryString.TrimStart().StartsWith("SELECT ", StringComparison.OrdinalIgnoreCase))
					{
						dt = TextQuery(queryString, cnnString);
						rows = dt.Rows.Count;
					}
					else
					{
						rows = NonQuery(queryString, cnnString);
					}
					break;
				default:
					rows = 0;
					break;
			}
			return dt;
		}
		public static DataTable TableQuery(string queryString, string cnnString)
		{
			DataTable dt = new DataTable();
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				DbCommand cmd = dbFactory.CreateCommand();
				DbDataAdapter adpt = dbFactory.CreateDataAdapter();
				cnn.ConnectionString = cnnString;
				cnn.Open();
				cmd.Connection = cnn;
				cmd.CommandText = queryString;
				cmd.CommandType = CommandType.TableDirect;
				adpt.SelectCommand = cmd;
				adpt.Fill(dt);
			}
			return dt;
		}
		public static DataTable TextQuery(string queryString, string cnnString)
		{
			DataTable dt = new DataTable();
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				DbCommand cmd = dbFactory.CreateCommand();
				DbDataAdapter adpt = dbFactory.CreateDataAdapter();
				cnn.ConnectionString = cnnString;
				cnn.Open();
				cmd.Connection = cnn;
				cmd.CommandText = queryString;
				cmd.CommandType = CommandType.Text;
				adpt.SelectCommand = cmd;
				adpt.Fill(dt);
			}
			return dt;
		}
		//TextQuery_OleDb()ܱTextQuery()Ժһ
		public static DataTable TextQuery_OleDb(string queryString, string cnnString)
		{
			DataTable dt = new DataTable();
			using (System.Data.OleDb.OleDbDataAdapter adpt = new System.Data.OleDb.OleDbDataAdapter(queryString, cnnString))
			{
				adpt.Fill(dt);
			}
			return dt;
		}
		public static int NonQuery(string queryString, string cnnString)
		{
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				cnn.ConnectionString = cnnString;
				cnn.Open();
				DbCommand cmd = dbFactory.CreateCommand();
				cmd.Connection = cnn;
				cmd.CommandText = queryString;
				return cmd.ExecuteNonQuery();
			}
		}
		public static object ScalarQuery(string queryString, string cnnString)
		{
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				cnn.ConnectionString = cnnString;
				cnn.Open();
				DbCommand cmd = dbFactory.CreateCommand();
				cmd.Connection = cnn;
				cmd.CommandText = queryString;
				return cmd.ExecuteScalar();
			}
		}
		//DataTable dt=new DataTable();dt.Load(ReaderQuery(...));ܱTextQuery(...)һ
		public static DbDataReader ReaderQuery(string queryString, string cnnString)
		{
			DbConnection cnn = dbFactory.CreateConnection();
			cnn.ConnectionString = cnnString;
			cnn.Open();
			DbCommand cmd = dbFactory.CreateCommand();
			cmd.Connection = cnn;
			cmd.CommandText = queryString;
			return cmd.ExecuteReader(CommandBehavior.CloseConnection);
		}
		public static object[] RowQuery(string queryString, string cnnString)
		{
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				cnn.ConnectionString = cnnString;
				cnn.Open();
				DbCommand cmd = dbFactory.CreateCommand();
				cmd.Connection = cnn;
				cmd.CommandText = queryString;
				DbDataReader reader = cmd.ExecuteReader(CommandBehavior.SingleRow | CommandBehavior.SingleResult);
				if (reader.Read())
				{
					object[] ret = new object[reader.FieldCount];
					reader.GetValues(ret);
					return ret;
				}
				else
				{
					return null;
				}
			}
		}
		public static object[] ColumnQuery(string queryString, string cnnString)
		{
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				cnn.ConnectionString = cnnString;
				cnn.Open();
				DbCommand cmd = dbFactory.CreateCommand();
				cmd.Connection = cnn;
				cmd.CommandText = queryString;
				DbDataReader reader = cmd.ExecuteReader(CommandBehavior.SingleResult);
				System.Collections.ArrayList ret = new System.Collections.ArrayList();
				while (reader.Read())
				{
					ret.Add(reader[0]);
				}
				reader.Close();
				return ret.ToArray();
			}
		}

		//ʽύһѯCommitʧԶRollback׳쳣
		public static List<DataTable> TransactionQuery(List<string> queries, string cnnString)
		{
			using (DbConnection cnn = dbFactory.CreateConnection())
			{
				cnn.ConnectionString = cnnString;
				cnn.Open();
				DbCommand cmd = dbFactory.CreateCommand();
				cmd.Connection = cnn;
				DbDataAdapter adpt = dbFactory.CreateDataAdapter();
				adpt.SelectCommand = cmd;
				List<DataTable> dts = new List<DataTable>();

				DbTransaction trans = cnn.BeginTransaction(); //Start a local transaction.
				cmd.Transaction = trans;
				try
				{
					foreach (string t in queries)
					{
						cmd.CommandText = t;
						if (t.TrimStart().StartsWith("SELECT ", StringComparison.OrdinalIgnoreCase))
						{
							DataTable dt = new DataTable();
							dt.TableName = t;
							adpt.Fill(dt);
							dts.Add(dt);
						}
						else
						{
							cmd.ExecuteNonQuery();
						}
					}
					trans.Commit(); //Attempt to commit the transaction.
					return dts; //Success
				}
				catch (Exception ex)
				{
					trans.Rollback(); //Attempt to roll back the transaction.Be carefull. It may fail and throw exception, too.
					throw ex;
				}
			}
		}
		public static List<DataTable> MultiQuery(List<string> queries, string cnnString)
		{
			List<DataTable> dts = new List<DataTable>();
			List<string> q = new List<string>();
			queries.Add("GO");
			foreach (string t in queries)
			{
				int i = t.IndexOf("--");
				string tt = i >= 0 ? t.Remove(i).Trim() : t.Trim();
				if (tt == "") continue;
				if (tt.ToUpper() == "GO")
				{
					dts.AddRange(TransactionQuery(q, cnnString));
					q.Clear();
				}
				else
				{
					q.Add(tt);
				}
			}
			return dts;
		}
		public static List<DataTable> MultiQuery(string queryText, string cnnString)
		{
			return MultiQuery(new List<string>(queryText.Split(new char[] { '\r', '\n' })), cnnString);
		}
		public static List<DataTable> FileQuery(string filename, string cnnString)
		{
			return MultiQuery(new List<string>(System.IO.File.ReadAllLines(filename)), cnnString);
		}
	}

	public static class SqlForm
	{
		public static System.Drawing.Rectangle DefaultRect;
		private static Form _createForm()
		{
			Form form = new Form();
			if (!DefaultRect.Location.IsEmpty)
			{
				form.StartPosition = FormStartPosition.Manual;
				form.Left = DefaultRect.Left;
				form.Top = DefaultRect.Top;
			}
			if (!DefaultRect.Size.IsEmpty)
			{
				form.Size = DefaultRect.Size;
			}
			return form;
		}
		private static DataGridView _createDataGrid()
		{
			DataGridView datagrid = new DataGridView();
			datagrid.Dock = DockStyle.Fill;
			datagrid.ReadOnly = true;
			datagrid.AllowUserToAddRows = false;
			datagrid.AllowUserToDeleteRows = false;
			return datagrid;
		}

		public static void RunScript(string cnnString)
		{
			OpenFileDialog ofd = new OpenFileDialog();
			ofd.Filter = "SQL Script (*.sql)|*.sql|All Files (*.*)|*.*";
			if (ofd.ShowDialog() == DialogResult.OK)
			{
				try
				{
					var reader = SqlTool.FileQuery(ofd.FileName, cnnString);
					if (reader.Count == 0)
						MessageBox.Show("Success");
					else
						SqlForm.ShowQueryResult(reader.ToArray());
				}
				catch (Exception ex)
				{
					MessageBox.Show(string.Format("Exception Type: {0}\r\nMessage: {1}", ex.GetType(), ex.Message), "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}

		public static Form ShowQueryResult(DataTable[] dts)
		{
			DataSet ds = new DataSet();
			ds.Tables.AddRange(dts);
			return ShowQueryResult(ds);
		}
		public static Form ShowQueryResult(DataSet ds)
		{
			Form form = _createForm();
			DataGridView datagrid = _createDataGrid();
			ListBox listbox = new ListBox();
			listbox.Dock = DockStyle.Left;
			listbox.HorizontalScrollbar = true;
			for (int i = 0; i < ds.Tables.Count; ++i)
			{
				listbox.Items.Add(ds.Tables[i].TableName);
			}
			listbox.SelectedIndexChanged += (sender, e) => { DataTable dt = ds.Tables[listbox.SelectedIndex]; datagrid.DataSource = dt; form.Text = dt.Rows.Count.ToString(); };
			form.Controls.Add(datagrid);
			form.Controls.Add(listbox);
			form.Show();
			return form;
		}
		public static Form ShowQueryResult(IDataReader reader)
		{
			DataTable dt = new DataTable();
			dt.Load(reader);
			return ShowQueryResult(dt);
		}
		public static Form ShowQueryResult(DataTable dt)
		{
			Form form = _createForm();
			DataGridView datagrid = _createDataGrid();
			datagrid.DataSource = dt;
			form.Controls.Add(datagrid);
			if (dt != null) form.Text = dt.Rows.Count.ToString();
			form.Show();
			return form;
		}
		public static Form ShowQueryResult(string queryString, string cnnString)
		{
			try
			{
				int rows;
				Form form = ShowQueryResult(SqlTool.ExecuteQuery(queryString, cnnString, SqlTool.QueryType.SQL, out rows));
				form.Text = string.Format("{0} ( {1} )", rows, queryString);
				return form;
			}
			catch (Exception ex)
			{
				MessageBox.Show(string.Format("Query: {0}\r\nException Type: {1}\r\nMessage: {2}", queryString, ex.GetType(), ex.Message), "Error");
				return null;
			}
		}

		public static Form ShowQueryForm(string cnnString, System.Collections.Specialized.StringCollection queryhistory)
		{
			Form form = _createForm();
			DataGridView datagrid = _createDataGrid();

			ComboBox input = new ComboBox();
			input.Dock = DockStyle.Top;
			input.Font = new System.Drawing.Font("Courier New", 9.75F);
			if (queryhistory != null)
			{
				foreach (string s in queryhistory)
				{
					input.Items.Add(s);
				}
			}
			input.KeyDown += delegate(object sender, KeyEventArgs e)
			{
				if (e.KeyCode == Keys.Return)
				{
					e.SuppressKeyPress = true; //ıڻسʱbeep
					try
					{
						string s = input.Text.Trim();
						if (s == "") return;
						input.Items.Remove(s);
						if (queryhistory != null) queryhistory.Remove(s);
						datagrid.DataSource = SqlTool.TextQuery(s, cnnString);
						input.Items.Insert(0, s);
						if (queryhistory != null) queryhistory.Insert(0, s);
						input.SelectedIndex = 0;
						form.Text = datagrid.RowCount.ToString();
					}
					catch (Exception ex)
					{
						System.Media.SystemSounds.Beep.Play();
						form.Text = "Error: " + ex.Message;
					}
				}
			};

			TreeView tv = new TreeView();
			tv.Dock = DockStyle.Fill;
			tv.NodeMouseDoubleClick += delegate(object sender, TreeNodeMouseClickEventArgs e)
			{
				TreeNode tn = e.Node;
				if (tn != null)
				{
					datagrid.DataSource = SqlTool.TableQuery(tn.Parent == null ? tn.Name : tn.Parent.Name, cnnString);
					form.Text = datagrid.RowCount.ToString();
					SqlTool.BuildTree(tv, cnnString);
					tv.ExpandAll();
				}
			};
			SqlTool.BuildTree(tv, cnnString);

			SplitContainer split = new SplitContainer();
			split.Dock = DockStyle.Fill;
			split.Panel1.Controls.Add(tv);
			split.Panel2.Controls.Add(datagrid);
			split.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;

			form.Controls.Add(split);
			form.Controls.Add(input);
			tv.ExpandAll();
			split.SplitterDistance = ToolProc.Tools.SuitableSize(tv).Width + split.SplitterWidth;
			form.Show();
			input.Focus();

			return form;
		}
		//ҪһΪ"QueryText"Ϊ"StringCollection"settingʷѯ佫浽setting
		public static Form ShowQueryForm(string cnnString, System.Configuration.ApplicationSettingsBase settings)
		{
			Form f = ShowQueryForm(cnnString, (System.Collections.Specialized.StringCollection)settings["QueryText"]);
			f.FormClosed += (sender, e) => settings.Save();
			return f;
		}
		public static Form ShowQueryForm(string cnnString)
		{
			return ShowQueryForm(cnnString, (System.Collections.Specialized.StringCollection)null);
		}
	}
}

namespace ToolProc
{
	public static class Tools
	{
		public static string InputBox(string prompt, string default_value)
		{
			Form form = new Form();
			form.Text = prompt;
			form.ShowInTaskbar = false;
			form.FormBorderStyle = FormBorderStyle.FixedDialog;
			form.MinimizeBox = false;
			form.MaximizeBox = false;
			form.StartPosition = FormStartPosition.CenterParent;

			TextBox textbox = new TextBox();
			textbox.Multiline = true;
			textbox.ScrollBars = ScrollBars.Vertical;
			textbox.Font = new System.Drawing.Font("Courier New", 9.75F);
			textbox.Dock = DockStyle.Fill;
			textbox.Text = default_value;

			Button ok = new Button();
			ok.Text = "OK";
			ok.DialogResult = DialogResult.OK;
			ok.Anchor = AnchorStyles.None; //ʹ


			Button cancel = new Button();
			cancel.Text = "Cancel";
			cancel.DialogResult = DialogResult.Cancel;
			cancel.Anchor = AnchorStyles.None; //ʹ

			TableLayoutPanel panel = new TableLayoutPanel();
			panel.RowCount = 2;
			panel.ColumnCount = 2;
			panel.RowStyles.Add(new RowStyle(SizeType.Percent, 60F));
			panel.RowStyles.Add(new RowStyle(SizeType.Percent, 40F));
			panel.ColumnStyles.Add(new ColumnStyle(SizeType.Percent, 50F));
			panel.ColumnStyles.Add(new ColumnStyle(SizeType.Percent, 50F));
			panel.Controls.Add(textbox, 0, 0);
			panel.Controls.Add(ok, 0, 1);
			panel.Controls.Add(cancel, 1, 1);
			panel.SetColumnSpan(textbox, 2);
			panel.Dock = DockStyle.Fill;

			form.Controls.Add(panel);

			string s = null;
			if (form.ShowDialog() == DialogResult.OK) s = textbox.Text;
			form.Dispose();
			return s;
		}

		public static System.Drawing.Size SuitableSize(TreeView tv)
		{
			return SuitableSize(tv.Nodes);
		}
		public static System.Drawing.Size SuitableSize(TreeNodeCollection tns)
		{
			System.Drawing.Size s = new System.Drawing.Size();

			foreach (TreeNode tn in tns)
			{
				if (tn.Bounds.Right > s.Width) s.Width = tn.Bounds.Right;
				if (tn.Bounds.Bottom > s.Height) s.Height = tn.Bounds.Height;
				System.Drawing.Size ss = SuitableSize(tn.Nodes);
				if (ss.Width > s.Width) s.Width = ss.Width;
				if (ss.Height > s.Height) s.Height = ss.Height;
			}
			return s;
		}
	}
}

